Генератор хешей: MD5, SHA-1, SHA-256

Введите текст, и вы увидите его хеши MD5, SHA-1, SHA-256, SHA-384 и SHA-512 в шестнадцатеричном виде. Добавьте ключ, и каждая строка станет HMAC, подписью, созданной с помощью секрета.

Бесплатно Работает в браузере Проверено вторник, 10 ноября 2026 г.

Текст для хеширования в кодировке UTF-8. Буквы кириллицы занимают по два байта каждая.

Оставьте поле пустым для обычных хешей. Если ключ задан, каждая строка становится HMAC, подписанным этим ключом.

Результат

Хеши

Этот инструмент работает в вашем браузере. То, что вы вводите, нам не отправляется.

Как пользоваться

  1. Введите или вставьте текст в поле Текст.
  2. Оставьте поле Ключ (необязательно) пустым для обычных хешей или введите ключ, чтобы получить HMAC.
  3. Скопируйте хеш из его строки или нажмите Скачать CSV, чтобы сохранить всю таблицу.
  4. Сверьте алгоритм в первом столбце с тем, который требует ваша система или документ.

Что такое хеш

Хеш-функция превращает любой текст в код фиксированной длины, который называют хешем или дайджестом. Один и тот же текст всегда даёт один и тот же хеш, небольшое изменение даёт совсем другой, а по хешу нельзя восстановить текст. Здесь хеши записаны в шестнадцатеричном виде: MD5 содержит 32 цифры, SHA-1 — 40, SHA-256 — 64, SHA-384 — 96, а SHA-512 — 128.

Шестнадцатеричные цифры = биты ÷ 4

MD5      128 ÷ 4 = 32
SHA-256  256 ÷ 4 = 64
SHA-512  512 ÷ 4 = 128

Какой алгоритм выбрать

MD5 и SHA-1 взломаны. Для двух разных текстов можно подобрать одинаковый хеш, поэтому их нельзя использовать для подписей и сертификатов. Они по-прежнему встречаются в старых системах и как быстрая проверка на случайное повреждение загрузки. SHA-256 и SHA-512 относятся к действующему стандарту FIPS 180-4 и обычно являются разумным выбором.

Чтобы хранить пароли, используйте функцию хеширования паролей, например Argon2 или bcrypt. Ни один хеш на этой странице для этого не предназначен.

HMAC: хеш с ключом

HMAC (RFC 2104) соединяет ключ с хешем по фиксированному правилу. Такой код может создать только тот, кто знает ключ, поэтому HMAC показывает, что сообщение пришло от известного отправителя и по пути не менялось. Страница считает HMAC теми же алгоритмами, что и обычные хеши.

Текст — это байты

  • Текст хешируется как байты UTF-8 (RFC 3629). Латинские буквы занимают один байт, кириллица и буквы вроде ğ или ş — два, а эмодзи — четыре.
  • Другой перенос строки, другая кодировка или один лишний пробел дают другой хеш, поэтому хешируйте те же байты, что и другой инструмент.

Пример: abc и HMAC

Хеши текста abc — опубликованные значения: MD5 приведён в RFC 1321, а SHA-1, SHA-256, SHA-384 и SHA-512 — в FIPS 180-4.

С ключом Jefe и текстом what do ya want for nothing? HMAC-SHA-256 равен 5bdcc146bf60754e6a042426089575c75a003f089d2739839dec58b964ec3843. Это проверочное значение RFC 4231, тестовый пример 2.

Алгоритм Хеш текста abc
MD5 900150983cd24fb0d6963f7d28e17f72
SHA-1 a9993e364706816aba3e25717850c26c9cd0d89d
SHA-256 ba7816bf8f01cfea414140de5dae2223b00361a396177a9cb410ff61f20015ad
SHA-384 cb00753f45a35e8bb5a03d699ac65007272c32ab0eded1631a8b605a43ff5bed8086072ba1e7cc2358baeca134c825a7
SHA-512 ddaf35a193617abacc417349ae20413112e6fa4e89a97ea20a9eeee64b55d39a2192992a274fc1a836ba3c23a3feebbd454d4423643ce80e2a9ac94fa54ca49f

Частые вопросы

MD5 безопасен для паролей?

Нет. MD5 быстрый и взломан, поэтому утёкший список хешей паролей MD5 легко подобрать. Храните пароли с помощью функции хеширования паролей, например Argon2 или bcrypt.

SHA-256 — это то же самое, что шифрование?

Нет. Хеш работает в одну сторону: из него нельзя восстановить текст, и он не использует ключ. Шифрование обратимо с правильным ключом. Хеш нужен для проверки целостности, а HMAC — чтобы проверить, что сообщение пришло от того, кто знает ключ.

Чем хеш отличается от HMAC?

Хеш зависит только от текста. HMAC также требует секретного ключа, поэтому создать или проверить его может только тот, у кого есть ключ. Подписи вебхуков и API обычно строятся на HMAC-SHA-256.

Почему мои хеши отличаются от хешей другого инструмента?

Байты должны совпадать. Другой перенос строки, другая кодировка, например Windows-1251, или лишний пробел меняют каждый хеш. Хешируйте те же байты, что хеширует другой инструмент.

Текст куда-нибудь отправляется?

Нет. Хеши считаются в вашем браузере, а текст не загружается и не сохраняется.

Можно ли проверить файл этим инструментом?

Эта страница хеширует только текст. Для файла используйте инструмент контрольных сумм вашей операционной системы или контрольную сумму, которую публикует сайт загрузки.

Источники

Цифры и текст в последний раз проверены вторник, 10 ноября 2026 г..

Мы используем необходимые cookie, чтобы сайт работал. С вашего согласия Google также использует рекламные cookie, чтобы показывать персонализированную рекламу. Если вы откажетесь, реклама всё равно будет показываться, но не будет персонализированной.